#define rfaclientRFAPP_BUILD
#include "application.hpp"
#include <iostream>

using namespace rfaclient;
using namespace std;

namespace {
	
    ConfigDatabasePtr
    create(const string& configPath, const string& appendixPath,
           const string& enumTypePath, bool initialLoad)
    {
        ConfigDatabasePtr configDatabase;
        try {
			configDatabase = createConfigDatabase(*createStagingConfigDatabase
                                                  (RFA_String(configPath)));
			/* Only read the market feed dictionary on the initial load */
            if (initialLoad) 
				readMfeedDictionary(appendixPath.c_str(), enumTypePath.c_str());
        } catch (const rfa::common::Exception& e) {
            throw MarketDataError(toString(e));
        }
        return configDatabase;
    }
}


RfaApplication::RfaApplication(const string& configPath,
                               const string& appendixPath,
                               const string& enumTypePath,
							   bool initialLoad)
    : configDatabase_(create(configPath, appendixPath, enumTypePath,initialLoad))
{
}


const std::string RfaApplication::getConfigValue(const std::string key) const {
	const rfa::config::ConfigTree* tree = configDatabase_->getConfigTree();
	const rfa::config::ConfigTree* pTree = static_cast<const rfa::config::ConfigTree*>(tree->getNode("Default\\"));
	RFA_String keyValue(key.c_str());
	std::string value = pTree->getChildAsString( keyValue );
	return value;
}