#ifndef rfaclientRFAPP_DISPATCHER_HPP
#define rfaclientRFAPP_DISPATCHER_HPP

#include "utility.hpp"

#include <boost/thread.hpp>
#include <boost/scoped_ptr.hpp>

#include <queue>

namespace rfaclient {

    class  RfaDispatcher : private boost::noncopyable {
        const unsigned timeout_;
        const boost::function0<void> timeoutFn_;
        boost::mutex mutex_;
        std::queue<EventQueuePtr> pending_;
        bool stop_;
        boost::scoped_ptr<boost::thread> thread_;
    public:
        ~RfaDispatcher();

		explicit
        RfaDispatcher(unsigned int timeout);

        RfaDispatcher(unsigned int timeout,
                      const boost::function0<void>& timeoutFn);

        void
        stop();

        void
        addEventQueue(const EventQueuePtr& eventQueue);

        void
        operator ()();
    };
}

#endif // rfaclientRFAPP_DISPATCHER_HPP
