#ifndef rfaclientRFAPP_MANAGER_HPP
#define rfaclientRFAPP_MANAGER_HPP

#include "client.hpp"
#include "dispatcher.hpp"
#include "publisher.hpp"
#include "subscriber.hpp"

#include <map>

namespace rfaclient {

	class  RfaManager {
		SessionPtr session_;
		EventQueuePtr eventQueue_;
		RfaClientAdapter clientAdapter_;
		RfaSubscriber subscriber_;
		RfaDispatcher dispatcher_;
		std::map<std::pair<std::string, std::string>,
			RfaSubscriptionPtr> subscriptions_;
	public:
		~RfaManager() ;

		RfaManager(const std::string& sessionName, RfaClientBase& client,
			unsigned timeout);

		RfaManager(const std::string& sessionName, RfaClientBase& client,
			unsigned timeout, const boost::function0<void>& timeoutFn
			);

		RfaManager(const std::string& sessionName, RfaClientBase& client,
			const PrincipalIdentity* identity,
			unsigned timeout, const boost::function0<void>& timeoutFn
			);


		void
			subscribe(const std::string& serviceName,
			const std::string& itemName);

		void
			unsubscribe(const std::string& serviceName,
			const std::string& itemName);

		void
			clear();
	};
}

#endif // rfaclientRFAPP_MANAGER_HPP
