#ifndef rfaclientRFAPP_SUBSCRIBER_HPP
#define rfaclientRFAPP_SUBSCRIBER_HPP

#include "utility.hpp"

namespace rfaclient {

	class  RfaSubscription {
		EventQueuePtr eventQueue_;
		rfa::sessionLayer::MarketDataSubscriber& subscriber_;
		Handle* handle_;

	public:
		~RfaSubscription() ;

		RfaSubscription(rfa::sessionLayer
			::MarketDataSubscriber& marketDataSubscriber,
			Handle* handle);
	};

	typedef boost::shared_ptr<RfaSubscription> RfaSubscriptionPtr;

	 RfaSubscriptionPtr
		createSubscription(rfa::sessionLayer
		::MarketDataSubscriber& marketDataSubscriber,
		rfa::common::EventQueue& eventQueue,
		const std::string& serviceName,
		const std::string& itemName,
		rfa::common::Client& client);

	class  RfaSubscriber {
		SessionPtr session_;
		EventQueuePtr eventQueue_;
		rfa::common::Client& client_;
		MarketDataSubscriberPtr subscriber_;
		Handle* handle_;

	public:
		~RfaSubscriber() ;

		RfaSubscriber(const SessionPtr& session,
			const EventQueuePtr& eventQueue,
			rfa::common::Client& client);

		RfaSubscriptionPtr
			createSubscription(const std::string& serviceName,
			const std::string& itemName);
	};
}

#endif // rfaclientRFAPP_SUBSCRIBER_HPP
