#ifndef _tsbycount_h
#define _tsbycount_h

#include "rtr/tseries.h"			// Defines RTRTimeSeries
#include "rtr/tsdefdb.h"                        // Defines RTRTSValDefDbClient

#include <R.h>
#include <Rinternals.h>


class TSClientByCount :
	public virtual RTRTimeSeriesClient, public virtual RTRTSValDefDbClient
{
public:
	// Number of samples-based constructor
	TSClientByCount(
			RTRTimeSeriesService& service,	// The service to use
			const char* item,				// name of instrument to retrieve
			int	num,						// the number of samples to retrieve
			RTRTimeSeriesService::Period period
			);

	// Date-based constructor
	TSClientByCount(
			RTRTimeSeriesService& service,	// The service to use
			const char* item,				// name of instrument to retrieve
			const char* startDate,						
			const char* endDate,
			RTRTimeSeriesService::Period period
			);

	// Event processing - from RTRTimeSeriesClient
	void processSeriesComplete(RTRTimeSeries&);
	// Process a "complete" event generated by the series.

	void processSeriesError(RTRTimeSeries&);
	// Process an error event generated by the series.

	void processSeriesInfo(RTRTimeSeries&);
	// Process an informational event generated by the series.

	//Event processing - from RTRValDefDbClient
	void processDefDbUpdate(RTRTSValDefDb&);
    // Process an update generate by the defDb
    
	void processDefDbComplete(RTRTSValDefDb&);
    // Process a "complete" event generated by the defDb. 

	SEXP& getFrame();

	bool dataReturned;

protected:
	RTRTimeSeries _series; 
	int _numSamples;
	RTRDateTime* _startDate;
	RTRDateTime* _endDate;
	bool _byDate;
	SEXP frame;
};

#endif 
